



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Permutation Sequence 解答</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Permutation Sequence 解答</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 11:02:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>Question</h3>
<p>The set&nbsp;<code>[1,2,3,&hellip;,<em>n</em>]</code>&nbsp;contains a total of&nbsp;<em>n</em>! unique permutations.</p>
<p>By listing and labeling all of the permutations in order,<br />We get the following sequence (ie, for&nbsp;<em>n</em>&nbsp;= 3):</p>
<ol><li><code>"123"</code></li>
<li><code>"132"</code></li>
<li><code>"213"</code></li>
<li><code>"231"</code></li>
<li><code>"312"</code></li>
<li><code>"321"</code></li></ol>
<p>Given&nbsp;<em>n</em>&nbsp;and&nbsp;<em>k</em>, return the&nbsp;<em>k</em>th&nbsp;permutation sequence.</p>
<p>Note:&nbsp;Given&nbsp;<em>n</em>&nbsp;will be between 1 and 9 inclusive.</p>
<h3>Solution -- Math</h3>
<p>We can conclude a pattern by obeservation.</p>
<p>[x<sub>1</sub>, x<sub>2</sub>, x<sub>3</sub>, .., x<sub>n</sub>]</p>
<p>If we fix x<sub>1</sub>, then number of permutations is (n - 1)!</p>
<p>If we fix x<sub>1&nbsp;</sub>and x<sub>2</sub>, then number of permutations is (n - 2)!</p>
<p>Following this thinking way, we can solve this problem by finding x<sub>i</sub> iteratively.</p>
<p>We also need a visited array here to note which element has been used.</p>
<div>
<pre class="prettyprint linenums"> public class Solution {<br />
     public String getPermutation(int n, int k) {<br />
         StringBuilder sb = new StringBuilder(n);<br />
         if (n &lt; 1 || n &gt; 9)<br />
             return sb.toString();<br />
         int factorial = 1;<br />
         for (int i = 1; i &lt;= n; i++) {<br />
             factorial *= i;<br />
         }<br />
         if (k &gt; factorial || k &lt; 1)<br />
             return sb.toString();<br />
         boolean[] visited = new boolean[n];

         int num = n;<br />
         int start = 1;<br />
         while (num &gt; 0) {<br />
             factorial /= num;<br />
             start += (k / factorial);<br />
             if (k % factorial == 0)<br />
                 start -= 1;<br />
             int index = 0;<br />
             for (int i = 1; i &lt;= n; i++) {<br />
                 // Find the right index<br />
                 if (!visited[i - 1])<br />
                     index++;<br />
                 if (index == start) {<br />
                     sb.append(i);<br />
                     visited[i - 1] = true;<br />
                     break;<br />
                 }<br />
             }<br />
             k = k - (start - 1) * factorial;<br />
             start = 1;<br />
             num--;<br />
         }<br />
         return sb.toString();<br />
     }<br />
 }</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1krl09.html">PHP 数据库连接工具类（MySQLI函数包装）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390djwj8.html">Unix&sol;Linux进程间通信（二）：匿名管道、有名管道 pipe&lpar;&rpar;、mkfifo&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdd7dxq.html">ShowDoc部署手册</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o5j659.html">调用微信JsAPI端获取位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93vz3w8.html">Can&amp;&num;39&semi;t connect to MySQL server on localhost &lpar;0&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j6yjgq.html">FMS发布视频流H&period;264如何设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ky0e9.html">&lbrack;DS Basics&rsqb; Data structures</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7yyyxq.html">IOC及Bean容器</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn7n3g8.html">usb驱动开发5之总线设备与接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv6pgz8.html">ovs-agent流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e10vkx9.html">java中final关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/90ve66n8.html">seajs构建方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zeom09.html">window快捷登陆linux的的设置方式（设置ssh的config配置）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj1pd28.html">【译】ASP&period;NET MVC 5 教程 - 10：添加验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwjg0q.html">bootstrap collapse  MVC  &period;net漂亮的折叠List</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdk0l49.html">java&lowbar;db2错误码对应值</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdvygz9.html">Spring之DAO一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1wykzq.html">Linux2&period;6--虚拟文件系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rz3jz8.html">thinkphp框架 的  链接数据库和操作数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2z41j9.html">Android视频压缩</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rdv2wd8.html">poj 3669 Meteor Shower（bfs）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjl40y9.html">C&num;中通过位运算实现多个状态的判断</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wp4wwq.html">MyWidget【简单自制控件】</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mkrjkq.html">python学习之路-9 socket网络编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1zvke9.html">PC-HTML5-搜索框</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1xyoj9.html">Android应用程序资源的查找过程分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1zp2z9.html">SQL Server 2008 geometry 数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wodyxq.html">JSP脚本元素上机手册</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1d1119.html">C&num; 十进制和十六进制转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj0jdy9.html">jdk内存</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
